/*
 * main.c
 *
 *  Created on: 2014-04-26
 *       Autor: ukasz Dachowski
 *
 *       Biblioteki do obsugi RC5 s autorstwa Mirosawa Karda
 *       mona je znale na doczonej pycie do ksiki pt.
 *       Mikrokontrolery AVR Jzyk C Podstawy programowaia
 *
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <avr/sleep.h>

#include "IR_DECODE/ir_decode.h"

//makrodefinicje wyj na przekaniki bistabilne
#define PRZ_PORT	PORTB	//porty na ktrym s przekaniki(dla Attiny13 wiadomo, e tylko B :D)
#define PRZ_DDR		DDRB


#define PRZ1ON_PIN	(1 << PB1)
#define PRZ1ON_INI	PRZ_DDR |= PRZ1ON_PIN
#define PRZ1ON_1	PRZ_PORT |= PRZ1ON_PIN
#define PRZ1ON_0	PRZ_PORT &= ~PRZ1ON_PIN
#define PRZ1OFF_PIN	(1 << PB2)
#define PRZ1OFF_INI	PRZ_DDR |= PRZ1OFF_PIN
#define PRZ1OFF_1	PRZ_PORT |= PRZ1OFF_PIN
#define PRZ1OFF_0	PRZ_PORT &= ~PRZ1OFF_PIN

#define PRZ2ON_PIN	(1 << PB3)
#define PRZ2ON_INI	PRZ_DDR |= PRZ2ON_PIN
#define PRZ2ON_1	PRZ_PORT |= PRZ2ON_PIN
#define PRZ2ON_0	PRZ_PORT &= ~PRZ2ON_PIN
#define PRZ2OFF_PIN	(1 << PB4)
#define PRZ2OFF_INI	PRZ_DDR |= PRZ2OFF_PIN
#define PRZ2OFF_1	PRZ_PORT |= PRZ2OFF_PIN
#define PRZ2OFF_0	PRZ_PORT &= ~PRZ2OFF_PIN

#define PRZ3ON_PIN	(1 << PB5)
#define PRZ3ON_INI	PRZ_DDR |= PRZ3ON_PIN
#define PRZ3ON_1	PRZ_PORT |= PRZ3ON_PIN
#define PRZ3ON_0	PRZ_PORT &= ~PRZ3ON_PIN

#define PRZ3_PORT	PORTC
#define PRZ3_DDR	DDRC
#define PRZ3OFF_PIN	(1 << PC0)
#define PRZ3OFF_INI	PRZ3_DDR |= PRZ3OFF_PIN
#define PRZ3OFF_1	PRZ3_PORT |= PRZ3OFF_PIN
#define PRZ3OFF_0	PRZ3_PORT &= ~PRZ3OFF_PIN

///* LED testowy do pokazywania odebranych danych */
#define LED_PORT	PORTD
#define LED_DDR 	DDRD
#define LED_PIN 	PD5
#define LED_INI 	LED_DDR	 |=  (1<<LED_PIN)
#define LED_OFF		LED_PORT |=  (1<<LED_PIN)
#define LED_ON		LED_PORT &= ~(1<<LED_PIN)
#define LED_TOG		LED_PORT ^=  (1<<LED_PIN)
//#define LED2_PIN 	PB3
//#define LED2_INI 	LED_DDR	 |=  (1<<LED2_PIN)
//#define LED2_OFF	LED_PORT |=  (1<<LED2_PIN)
//#define LED2_ON		LED_PORT &= ~(1<<LED2_PIN)
//#define LED2_TOG	LED_PORT ^=  (1<<LED2_PIN)
#define wy_int_PORT		PORTD
#define wy_int_DDR 		DDRD
#define wy_int_PIN 		PD3
#define wy_int_INI 		wy_int_DDR |=  (1<<wy_int_PIN)
#define wy_int_ON		wy_int_PORT |=  (1<<wy_int_PIN)
#define wy_int_OFF		wy_int_PORT &= ~(1<<wy_int_PIN)

uint16_t pomiar(uint8_t kanal);		//deklaracja funkcji pomiaru

uint8_t i;
uint16_t pom;
uint16_t sle;

int main(void) {
	// inicjalizacja wyj na przekaniki bistabilne
	PRZ1ON_INI;
	PRZ1OFF_INI;
	PRZ2ON_INI;
	PRZ2OFF_INI;
	PRZ3ON_INI;
	PRZ3OFF_INI;
	LED_INI;
	LED_OFF;
	wy_int_INI;
	wy_int_ON;


	ir_init();	/* inicjalizacja dekodowania IR */

	//wcz moliwo usypiania do trybu PWR_DOWN
	sleep_enable();
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);

	// ustawienie pinu PORTD.2 (INT0) jako wejcie
	DDRD &= ~(1<<PD2);
	// podcignicie do 1
	PORTD |= (1<<PD2);
	// zezwolenie na przerwania INT0
	EIMSK |= (1<<INT0);
	// skasowanie flagi wystpienia przerwania INT0
	EIFR |= (1<<INTF0);

	sei();	/* wczamy globalne przerwania */

	ADMUX |= (1<<REFS0)|(1<<REFS1); // 1,1V
	ADCSRA |= (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);	//wczenie moduu ADC oraz ustawienie preskalerana 64


	/* ptla nieskoczona */
	while(1) {
		if(Ir_key_press_flag) {	/* jeli odebrano prawidowe kody z pilota */

						pom=0;
						for(i=0;i<10;i=i+1)
						{
						pom += pomiar(1);
						}
						pom /= 10;
						if(pom < 717) {	//717 przy dzielniku z rez. 10k i 2,2k; ARF=1,1V = 4,4V
							PRZ1OFF_1;
							PRZ2OFF_1;
							PRZ3OFF_1;
							_delay_ms(300);
							PRZ1OFF_0;
							PRZ2OFF_0;
							PRZ3OFF_0;
							while(1){
								LED_TOG;
								_delay_ms(500);
							}
						}

						if( !address ) {		/* jeli adres == 0 */

							if(command == 32){		//ch+
								PRZ1ON_1;
								_delay_ms(300);
								PRZ1ON_0;
							}
							if(command == 17){		//vol-
								PRZ1OFF_1;
								_delay_ms(300);
								PRZ1OFF_0;
							}

							if(command == 13){		//mute
								PRZ2ON_1;
								_delay_ms(300);
								PRZ2ON_0;
							}
							if(command == 11){		//AV/TV
								PRZ2OFF_1;
								_delay_ms(300);
								PRZ2OFF_0;
							}

							if(command == 33){		//CH-
								PRZ3ON_1;
								_delay_ms(300);
								PRZ3ON_0;
							}
							if(command == 16){		//vol-
								PRZ3OFF_1;
								_delay_ms(300);
								PRZ3OFF_0;
							}

							if(command == 12){		//OFF
								PRZ1OFF_1;
								PRZ2OFF_1;
								PRZ3OFF_1;
								_delay_ms(300);
								PRZ1OFF_0;
								PRZ2OFF_0;
								PRZ3OFF_0;
							}

			//				_delay_ms(500);
						}


						/* wyzerowanie flagi odbioru oraz wartoci odebranych kodw */
						Ir_key_press_flag=0;
						command=0xff;
						address=0xff;
						LED_OFF;
						wy_int_ON;			//wczenie TCP do INT
						sle=0;
						sleep_cpu(); //pij
					}
		else{								//za ramka
			_delay_ms(1);
			sle++;
			if(sle>5000){					//mineo 5s
				sle=0;
				LED_OFF;
				wy_int_ON;
				sleep_cpu(); //pij
			}
		}

		//				sleep_cpu(); //pij
	}
}

// definincja funkcje,ktra dokonuje pomiaru na wybranym kanale/wejciu
uint16_t pomiar(uint8_t kanal) {
	//ustawienie wybranego kanau w rejestrze ADMUX
	ADMUX = (ADMUX & 0xF8) | kanal;
	//START pomaiaru przez ustawienie bitu ADSC w rejestrze ADCSR
	ADCSRA |= (1<<ADSC);
	//oczekiwanie na koniec promiaru (dopki bit ADSC jest =1)
	while( ADCSRA & (1<<ADSC));

	return ADCW;
}

ISR(INT0_vect) {
	LED_ON;
	wy_int_OFF;
}
